library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity Forum_FIR is Port(
	clk: in std_logic;
	data_in: in std_logic_vector(15 downto 0);
	data_in_valid: in std_logic;
	data_out: out std_logic_vector(15 downto 0);
	data_out_valid: out std_logic);
end Forum_FIR;

architecture Behavioral of Forum_FIR is

type ASOP is array (0 to 63) of signed(31 downto 0);
signal a_sop: ASOP:=(others => x"00000000");
type ACOEF is array (0 to 63) of integer range -2**15 to 2**15-1;
signal a_coeff: ACOEF:=
(0,0,-3,-2,21,56,40,-55,-140,-101,17,42,-52,-32,262,544,324,
-378,-861,-567,93,212,-247,-147,1219,2561,1587,-1988,-5111,
-4123,985,5827,5827,985,-4123,-5111,-1988,1587,2561,1219,
-147,-247,212,93,-567,-861,-378,324,544,262,-32,-52,42,17,
-101,-140,-55,40,56,21,-2,-3,0,0);

begin

process begin
wait until rising_edge(clk);
	data_out_valid <= '0';
	if data_in_valid = '1' then
		data_out_valid <= '1';
		a_sop(0) <= signed(data_in) * to_signed(a_coeff(63),16);
		for I in 1 to 63 loop
			a_sop(I) <= signed(data_in) * to_signed(a_coeff(I),16) + a_sop(I-1);
		end loop;
		data_out <= std_logic_vector(a_sop(63)(31 downto 16));
	end if;
end process;

end Behavioral;